package com.jpsoft.picc.test;

import com.jpsoft.picc.modules.business.entity.InsurancePolicy;
import com.jpsoft.picc.modules.business.service.InsurancePolicyService;
import com.jpsoft.picc.modules.sys.service.DataDictionaryService;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.annotation.Rollback;
import org.springframework.test.context.junit4.SpringRunner;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;

import java.lang.reflect.Executable;
import java.util.Date;

@RunWith(SpringRunner.class)
@SpringBootTest
public class PolicyTest {
    @Autowired
    private InsurancePolicyService insurancePolicyService;

    @Autowired
    private DataDictionaryService dataDictionaryService;

    @Transactional(rollbackFor=Exception.class,propagation=Propagation.REQUIRED)
    public void transactionMethod(){
        InsurancePolicy policy = insurancePolicyService.get("78e7de89-d903-41e5-9b5d-73205baed84a");
        policy.setStatus("70");
        insurancePolicyService.update(policy);

        //insurancePolicyService.findNextMonthPolicy("1", "2", new Date(), "3", "4");
    }

    @Test
    @Transactional(rollbackFor=Exception.class,propagation=Propagation.REQUIRED)
    public void test1(){
        try {
            transactionMethod();
        }catch (Exception ex){
            //在实际开发中，我们往往需要在方法中进行异常的捕获，从而对异常进行判断，为客户端返回提示信息。
            //但是此时由于异常的被捕获，导致事务的回滚没有被触发，导致事务的失败。
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            System.out.println(ex.getMessage());
        }
    }

    @Test
    public void test2(){
        dataDictionaryService.findNameByCatalogNameAndValue("123","4565");
    }
}
