package com.jpsoft.picc.modules.base.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;

import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiModel;

/**
  描述:base_company_member的实体类
 */
@Data
@ApiModel(value = "base_company_member的实体类")
public class CompanyMember {
    @ApiModelProperty(value = "ID")
	private String id;
    @ApiModelProperty(value = "企业ID")
	private String companyId;
    @ApiModelProperty(value = "姓名")
	private String name;
    @ApiModelProperty(value = "证件类型(值)")
	private String cardType;
	@ApiModelProperty(value = "证件类型(名称)")
	private String cardTypeN;
    @ApiModelProperty(value = "证件编号")
	private String cardNo;
    @ApiModelProperty(value = "性别")
	private Boolean sex;
	@DateTimeFormat(pattern="yyyy-MM-dd")
	@JsonFormat(pattern = "yyyy-MM-dd",timezone ="GMT+8")
	@ApiModelProperty(value = "生日")
	private Date birthday;
    @ApiModelProperty(value = "年龄")
	private Integer age;
    @ApiModelProperty(value = "岗位ID")
	private String jobsId;
	@ApiModelProperty(value = "岗位名称")
	private String jobName;
    @ApiModelProperty(value = "健康状态")
	private String healthStatus;
    @ApiModelProperty(value = "身份证附件")
	private String cardFiles;
    @ApiModelProperty(value = "状态")
	private String status;
    @ApiModelProperty(value = "创建人")
	private String createBy;
	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    @ApiModelProperty(value = "创建时间")
	private Date createTime;
    @ApiModelProperty(value = "更新人")
	private String updateBy;
	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    @ApiModelProperty(value = "更新时间")
	private Date updateTime;
    @ApiModelProperty(value = "是否删除")
	private Boolean delFlag;
}