package com.jpsoft.picc.modules.base.service.impl;

import java.util.*;
import javax.annotation.Resource;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;
import com.jpsoft.picc.modules.base.dao.JobsDAO;
import com.jpsoft.picc.modules.base.entity.Jobs;
import com.jpsoft.picc.modules.base.service.JobsService;
import com.github.pagehelper.Page;
import com.jpsoft.picc.modules.common.dto.Sort;
import com.github.pagehelper.PageHelper;

@Transactional
@Component(value="jobsService")
public class JobsServiceImpl implements JobsService {
	@Resource(name="jobsDAO")
	private JobsDAO jobsDAO;

	@Override
	public Jobs get(String id) {
		// TODO Auto-generated method stub
		return jobsDAO.get(id);
	}

	@Override
	public int insert(Jobs model) {
		// TODO Auto-generated method stub
		//model.setId(UUID.randomUUID().toString());
		
		return jobsDAO.insert(model);
	}

	@Override
	public int update(Jobs model) {
		// TODO Auto-generated method stub
		return jobsDAO.update(model);		
	}

	@Override
	public int delete(String id) {
		// TODO Auto-generated method stub
		return jobsDAO.delete(id);
	}

	@Override
	public boolean exist(String id) {
		// TODO Auto-generated method stub
		int count = jobsDAO.exist(id);
		
		return count > 0 ? true : false;
	}
	
	@Override
	public List<Jobs> list() {
		// TODO Auto-generated method stub
		return jobsDAO.list();
	}

		
	@Override
	public Page<Jobs> pageSearch(Map<String, Object> searchParams, int pageNumber, int pageSize,List<Sort> sortList) {
        Page<Jobs> page = PageHelper.startPage(pageNumber,pageSize).doSelectPage(()->{
            jobsDAO.search(searchParams,sortList);
        });
        
        return page;
	}

	@Override
	public List<Jobs> findByName(String jobName) {
		Map<String,Object> searchParams = new HashMap<>();
		searchParams.put("name","%" + jobName + "%");

		List<Sort> sortList = new ArrayList<>();
		sortList.add(new Sort("name_","asc"));

		return jobsDAO.search(searchParams,sortList);
	}
}