package com.jpsoft.picc.modules.business.service;

import com.github.pagehelper.Page;
import com.jpsoft.picc.modules.business.entity.InsuranceApplication;
import com.jpsoft.picc.modules.common.dto.Sort;

import java.util.Date;
import java.util.List;
import java.util.Map;

public interface InsuranceApplicationService {
    InsuranceApplication get(String id);

    boolean exist(String id);

    int insert(InsuranceApplication model);

    int update(InsuranceApplication model);

    int delete(String id);

    List<InsuranceApplication> list();

    Page<InsuranceApplication> pageSearch(Map<String, Object> searchParams, int pageNum, int pageSize, List<Sort> sortList);

    List<InsuranceApplication> findByCompanyId(String companyId,String status);

    List<InsuranceApplication> findByCompanyIdAndCreatTime(String companyId,String status,String startTime,String endTime);

    List<InsuranceApplication> findByDuration(String companyId, String definitionId, Date startTime, Date endTime,String[] status);

    List<InsuranceApplication> findByCombinePolicyId(String policyId);

    /**
     * 生成投保单号（yyMMdd）+(XXX=今日第几单)+(XX=第几个月)
     * @param createTime
     * @return
     */
    String generatePolicyNo(Date createTime,int num);
    long countByCreateTime(Date createTime);
}