package com.jpsoft.picc.modules.common.utils;

import java.io.StringReader;
import java.io.StringWriter;
import java.util.HashMap;
import java.util.Map;
import java.util.Properties;

import org.apache.velocity.VelocityContext;
import org.apache.velocity.app.Velocity;
import org.apache.velocity.app.VelocityEngine;

public class VelocityHelper {
	private static VelocityEngine velocityEngine;
	
	public static synchronized VelocityEngine getEngine() {
		if (velocityEngine==null) {
			Properties properties=new Properties();
			
			properties.setProperty(Velocity.ENCODING_DEFAULT, "UTF-8");
	        properties.setProperty(Velocity.INPUT_ENCODING, "UTF-8");
	        properties.setProperty(Velocity.OUTPUT_ENCODING, "UTF-8");
	        
	        velocityEngine = new VelocityEngine(properties);
		}
		
		return velocityEngine;
	}
	
	public static String format(String tmplContent,Map<String,Object> variables) {
		VelocityEngine velocityEngine = VelocityHelper.getEngine();
		
        VelocityContext context=new VelocityContext();
        
        for (String key : variables.keySet()) {
			context.put(key, variables.get(key));
		}
        
        StringWriter writer = new StringWriter();
        StringReader reader = new StringReader(tmplContent);
        
        velocityEngine.evaluate(context, writer, "test", reader);
        
        return writer.toString();
	}
}
